



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>slf4j日志框架绑定机制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">slf4j日志框架绑定机制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 02:12:38 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、环境搭建</h2>
<p>我们以log4j为例，探寻slf4j与log4j的绑定过程。</p>
<p>1.Java类</p>
<div>
<pre class="prettyprint linenums">public class Slf4jBind {<br />
    public static void main(String[] args) {<br />
        Logger LOGGER = LoggerFactory.getLogger(Slf4jBind.class);<br />
        LOGGER.info("slf4j hello world");<br />
    }<br />
}</pre>
</div>
<p>2.log4j.properties文件</p>
<p>来自<a href="https://docs.oracle.com/cd/E29578_01/webhelp/cas_webcrawler/src/cwcg_config_log4j_file.html" rel="external nofollow noreferrer">https://docs.oracle.com/cd/E29578_01/webhelp/cas_webcrawler/src/cwcg_config_log4j_file.html</a></p>
<div>
<pre class="prettyprint linenums">log4j.rootLogger=ERROR,stdout<br />
log4j.logger.com.endeca=INFO<br />
# Logger for crawl metrics<br />
log4j.logger.com.endeca.itl.web.metrics=INFO<br />
​<br />
log4j.appender.stdout=org.apache.log4j.ConsoleAppender<br />
log4j.appender.stdout.layout=org.apache.log4j.PatternLayout<br />
log4j.appender.stdout.layout.ConversionPattern=%p\t%d{ISO8601}\t%r\t%c\t[%t]\t%m%n</pre>
</div>
<p>3.Maven的pom.xml中添加如下依赖</p>
<div>
<pre class="prettyprint linenums">&lt;dependency&gt;<br />
    &lt;groupId&gt;org.slf4j&lt;/groupId&gt;<br />
    &lt;artifactId&gt;slf4j-log4j12&lt;/artifactId&gt;<br />
    &lt;version&gt;1.6.4&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;org.slf4j&lt;/groupId&gt;<br />
    &lt;artifactId&gt;slf4j-api&lt;/artifactId&gt;<br />
    &lt;version&gt;1.6.4&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;log4j&lt;/groupId&gt;<br />
    &lt;artifactId&gt;log4j&lt;/artifactId&gt;<br />
    &lt;version&gt;1.2.16&lt;/version&gt;<br />
&lt;/dependency&gt;</pre>
</div>
<p>其中，slf4j-api定义接口的包。</p>
<p>slf4j-log4j12为slf4j与logj之间的桥接包。</p>
<p>log4j为log4j的具体实现包。</p>
<p>4.单步跟踪</p>
<p>在main函数处打断点，debug模式下单步跟踪即可</p>
<h2>二、slf4j绑定log4j流程</h2>
<p>main函数中调用LoggerFactory.getLogger时，将依次执行下面的函数。</p>
<p>slf4j对LoggerFactroy的说明如下：</p>
<p>LoggerFactory是为各个日志API生成Logger的帮助类。</p>
<p>如log4j，logback，jdk 1.4 logging，也支持NOPLogger，SimpleLogger。</p>
<p>LoggerFactory内部封装了ILoggerFactory，具体的ILoggerFactory与LoggerFactory在编译期(complile time)绑定。</p>
<div>
<pre class="prettyprint linenums">public static Logger getLogger(Class clazz) {<br />
  return getLogger(clazz.getName());<br />
}

public static Logger getLogger(String name) {<br />
  ILoggerFactory iLoggerFactory = getILoggerFactory();<br />
  return iLoggerFactory.getLogger(name);<br />
}<br />
​<br />
/<br />
 * ILoggerFactory instance is bound with this class at compile time.<br />
 *<br />
 * @return the ILoggerFactory instance in use<br />
 */<br />
public static ILoggerFactory getILoggerFactory() {<br />
  if (INITIALIZATION_STATE == UNINITIALIZED) {<br />
    INITIALIZATION_STATE = ONGOING_INITILIZATION;<br />
    performInitialization();<br />
​<br />
  }<br />
  switch (INITIALIZATION_STATE) {<br />
  case SUCCESSFUL_INITILIZATION:<br />
    return StaticLoggerBinder.getSingleton().getLoggerFactory();<br />
  case NOP_FALLBACK_INITILIZATION:<br />
    return NOP_FALLBACK_FACTORY;<br />
  case FAILED_INITILIZATION:<br />
    throw new IllegalStateException(UNSUCCESSFUL_INIT_MSG);<br />
  case ONGOING_INITILIZATION:<br />
    // support re-entrant behavior.<br />
    // See also http://bugzilla.slf4j.org/show_bug.cgi?id=106<br />
    return TEMP_FACTORY;<br />
  }<br />
  throw new IllegalStateException("Unreachable code");<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">private final static void performInitialization() {<br />
  //对具体的日志框架实现是否仅有一个进行check<br />
  singleImplementationSanityCheck();<br />
  //与具体的日志框架绑定<br />
  bind();<br />
  if (INITIALIZATION_STATE == SUCCESSFUL_INITILIZATION) {<br />
  //版本依赖兼容性check<br />
    versionSanityCheck();<br />
  }<br />
}</pre>
</div>
<p>1.对具体的日志框架实现是否仅有一个进行check。</p>
<p>1).判断classpath下是否有多个org/slf4j/impl/StaticLoggerBinder.class</p>
<p>2).如果有多个，将提示有多个SLF4J的绑定包。</p>
<div>
<pre class="prettyprint linenums">private static String STATIC_LOGGER_BINDER_PATH = "org/slf4j/impl/StaticLoggerBinder.class";<br />
​<br />
private static void singleImplementationSanityCheck() {<br />
  try {<br />
    ClassLoader loggerFactoryClassLoader = LoggerFactory.class<br />
        .getClassLoader();<br />
    Enumeration paths;<br />
    if (loggerFactoryClassLoader == null) {<br />
      paths = ClassLoader.getSystemResources(STATIC_LOGGER_BINDER_PATH);<br />
    } else {<br />
      paths = loggerFactoryClassLoader<br />
          .getResources(STATIC_LOGGER_BINDER_PATH);<br />
    }<br />
    // use Set instead of list in order to deal with  bug #138<br />
    // LinkedHashSet appropriate here because it preserves insertion order during iteration<br />
    Set implementationSet = new LinkedHashSet();<br />
    while (paths.hasMoreElements()) {<br />
      URL path = (URL) paths.nextElement();<br />
      implementationSet.add(path);<br />
    }<br />
    if (implementationSet.size() &gt; 1) {<br />
      Util.report("Class path contains multiple SLF4J bindings.");<br />
      Iterator iterator = implementationSet.iterator();<br />
      while(iterator.hasNext()) {<br />
        URL path = (URL) iterator.next();<br />
        Util.report("Found binding in [" + path + "]");<br />
      }<br />
      Util.report("See " + MULTIPLE_BINDINGS_URL + " for an explanation.");<br />
    }<br />
  } catch (IOException ioe) {<br />
    Util.report("Error getting resources from path", ioe);<br />
  }<br />
}</pre>
</div>
<p>2.绑定具体的日志框架</p>
<p>根据找到的org/slf4j/impl/StaticLoggerBinder.class，执行StaticLoggerBinder.getSingleton()进行绑定。</p>
<div>
<pre class="prettyprint linenums">private final static void bind() {<br />
  try {<br />
    // the next line does the binding<br />
    StaticLoggerBinder.getSingleton();//绑定<br />
    INITIALIZATION_STATE = SUCCESSFUL_INITILIZATION;<br />
    emitSubstituteLoggerWarning();<br />
  } catch (NoClassDefFoundError ncde) {<br />
    String msg = ncde.getMessage();<br />
    if (messageContainsOrgSlf4jImplStaticLoggerBinder(msg)) {<br />
      INITIALIZATION_STATE = NOP_FALLBACK_INITILIZATION;<br />
      Util<br />
          .report("Failed to load class \"org.slf4j.impl.StaticLoggerBinder\".");<br />
      Util.report("Defaulting to no-operation (NOP) logger implementation");<br />
      Util.report("See " + NO_STATICLOGGERBINDER_URL<br />
          + " for further details.");<br />
    } else {<br />
      failedBinding(ncde);<br />
      throw ncde;<br />
    }<br />
  } catch(java.lang.NoSuchMethodError nsme) {<br />
    String msg = nsme.getMessage();<br />
    if (msg != null &amp;&amp; msg.indexOf("org.slf4j.impl.StaticLoggerBinder.getSingleton()") != -1) {<br />
      INITIALIZATION_STATE = FAILED_INITILIZATION;<br />
      Util.report("slf4j-api 1.6.x (or later) is incompatible with this binding.");<br />
      Util.report("Your binding is version 1.5.5 or earlier.");<br />
      Util.report("Upgrade your binding to version 1.6.x. or 2.0.x");<br />
    }<br />
    throw nsme;<br />
  } catch (Exception e) {<br />
    failedBinding(e);<br />
    throw new IllegalStateException("Unexpected initialization failure", e);<br />
  }<br />
}</pre>
</div>
<p>因为具体的日志框架为log4j，StaticLoggerBinder返回的为Log4j的LoggerFactory。</p>
<div>
<pre class="prettyprint linenums">private final ILoggerFactory loggerFactory;<br />
​<br />
private StaticLoggerBinder() {<br />
  loggerFactory = new Log4jLoggerFactory();<br />
  try {<br />
    Level level = Level.TRACE;<br />
  } catch (NoSuchFieldError nsfe) {<br />
    Util<br />
        .report("This version of SLF4J requires log4j version 1.2.12 or later. See also http://www.slf4j.org/codes.html#log4j_version");<br />
  }<br />
}<br />
 &nbsp;</pre>
</div>
<p>经过以上步骤，slf4j将于具体的日志框架log4j绑定。</p>
<p>如下所示，ILoggerFactory实际返回类型为Log4jLoggerFactory。</p>
<p>并调用Log4jLoggerFactory中的getLogger方法返回Log4jLogger用于log写入。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/676975/201902/676975-20190222134349685-674324232.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/676975/201902/676975-20190222134402491-1150226312.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390vvy38.html">Javascript前端和JAVA后端对加密库的处理实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/49501lv8.html">ASP&period;NET - 回滚事务</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g45079.html">C&plus;&plus; 中的sort排序用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdxkgz8.html">java对redis的基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o2poe9.html">Js实现简单的省市级联的效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvo2nx8.html">PHP实现各种经典算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm70409.html">Android Back Home键监听</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv13e41q.html">maven的介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j7d3x8.html">P1265 公路修建  最小生成树</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjm4z49.html">Linux 安装aria2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvegpz8.html">PYTHON-模块 logging hashlib</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjxzo59.html">python-初始化函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kmekvq.html">BZOJ1307&colon; 玩具 单调队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnywljq.html">基于OpenGL编写一个简易的2D渲染框架-02 搭建OpenGL环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em374m9.html">数据库对比：选择MariaDB还是MySQL？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emxmnx9.html">WebSphere概要文件管理工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p04pg8.html">IE edge是怎么了？？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44d5y3q.html">leetcode605</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3z4wlq.html">【SSO单点系列】（6）：CAS4&period;0 单点流程序列图（中文版）以及相关术语解释（TGT、ST、PGT、PT、PGTIOU）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e0k7ejq.html">struts1学习</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o4xe75q.html">C&num; 一、语法结构、注释、命名空间、Main入口点、变量与常量、运算符、流程控制（循环）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmy3k49.html">巨蟒python全栈开发flask11项目开始3</a>
			</li>
						<li><a href="https://www.batexi.com/a/9636v239.html">FormsAuthentication 使用指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4perg0q.html">Content-Negotiation Header Quality Values</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvemy2q.html">Logstash利用GeoIP库显示地图以及通过useragent显示浏览器（</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl71ol9.html">cross-compler toolchains--clfs</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvem6xq.html">Redis的基本使用&lpar;基于maven和spring&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj6n3jq.html">Docker与virtualenv</a>
			</li>
						<li><a href="https://www.batexi.com/a/96361yv9.html">剑指Offer&mdash;&mdash;数值的整数次方</a>
			</li>
						<li><a href="https://www.batexi.com/a/96361gj9.html">HDFS分布式集群安装</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
